Imports System
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Windows.Forms
' the novapiLib package must be added as a    COM    refference
Imports novapiLib90


Module Module1
	'    <summary>
	'    The    main entry point for the application.
	'    </summary>
    Const PRINTER_NAME As String = "novaPDF SDK 9"

	Const PROFILE_NAME As String = "Word OLE VBNet"
	Const PROFILE_IS_PUBLIC As Integer = 0
    Const NOVAPDF_INFO_SUBJECT As Integer = 68

    Const NV_PROFILE_EXISTS As Long = -707133434
    Const NV_NO_ACTIVE_PROFILE As Long = &HD5DA0028

	Sub Main()
		Try
            ' create the NovaPdfOptions80 object
            Dim pNova As NovaPdfOptions90
            pNova = New NovaPdfOptions90
            Dim activeProfile As String = ""
            Dim newProfileID As String = String.Empty

            ' initialize the NovaPdfOptions80 object
            ' if you have an application license for novaPDF SDK,
            ' pass the license key to the Initialize() function
            pNova.Initialize(PRINTER_NAME, "")

            Try
                pNova.GetActiveProfile(activeProfile)
            Catch e As System.Runtime.InteropServices.COMException
                'gnore profile exists error
                If (Word_OLE.NV_NO_ACTIVE_PROFILE = e.ErrorCode) Then
                    System.Console.WriteLine("The printer does not have an active profile")
                Else
                    ' more	serious	error, propagate it
                    Throw e
                End If
            End Try

            Try
                ' create new profile
                pNova.AddProfile(PROFILE_NAME, PROFILE_IS_PUBLIC, newProfileID)
            Catch e As System.Runtime.InteropServices.COMException
                ' ignore profile exists error
                If (NV_PROFILE_EXISTS = e.ErrorCode) Then
                    System.Console.WriteLine("Profile already exists")
                Else
                    ' more    serious    error, propagate it
                    Throw e
                End If
            End Try

            'load the new profile
            pNova.LoadProfile(newProfileID)
            'and set some	options
            pNova.SetOptionString(NOVAPDF_INFO_SUBJECT, "C#	Hello document")
            pNova.SaveProfile()
            'set the copy	profile	as active profile ...
            pNova.SetActiveProfile(newProfileID)
            'set nova default printer

            ' set nova default printer
            pNova.SetDefaultPrinter()
            ' print word document
            Dim objWord As Object
            Dim objDoc As Object
            pNova.InitializeOLEUsage("Word.Application")
            objWord = CreateObject("Word.Application")
            pNova.LicenseOLEServer()
            objDoc = objWord.Documents.Open("C:\temp\test.docx", False, True)
            objDoc.PrintOut(False)
            objDoc.Close(False)
            objWord.Quit(False)

            ' restore active profile
            pNova.SetActiveProfile(activeProfile)
            pNova.DeleteProfile(newProfileID)

            ' restore default printer
            pNova.RestoreDefaultPrinter()
        Catch e As System.Runtime.InteropServices.COMException
            MessageBox.Show(e.Message)
        Catch e As Exception
            MessageBox.Show(e.Message)
        End Try
    End Sub

	' and finally the function that actually prints the page
	Private Sub PrintPageFunction(ByVal sender As Object, ByVal ev As PrintPageEventArgs)
		Dim str As String = "novaPDF says Hello World from VB.Net"
		Dim font As Font = New Font("Arial", 16)
		Dim brush As Brush = New SolidBrush(Color.Black)
		ev.Graphics.DrawString(str, font, brush, 20.0!, 20.0!)
		ev.HasMorePages = False
	End Sub

End Module
